<template>
  <v-card
    id="correction-statistics"
    class="py-2"
  >
    <v-card-title>
      <span class="title">Statistics</span>
    </v-card-title>
    <div v-if="loaded">
      <ul class="inline-list mx-3">
        <li>Submissions per participant: <span>{{ statistics.submissionsPerStudent }}</span></li>
        <li>Submissions per type: <span>{{ statistics.submissionsPerType }}</span></li>
        <li>
          Curr. mean score:
          <span>
            {{ statistics.currentMeanScore === null ? 'N.A.' : statistics.currentMeanScore.toFixed(2) }}
          </span>
        </li>
      </ul>
      <v-divider class="mx-2 my-2" />
      <div
        v-for="(progress, index) in statistics.submissionTypeProgress"
        :key="index"
      >
        <v-card-title class="py-0">
          {{ progress.name }}
        </v-card-title>
        <div class="mx-3">
          <v-progress-linear
            :value="progress.feedbackFinal / progress.submissionCount * 100"
            buffer
            :buffer-value="(progress.feedbackInValidation + progress.feedbackFinal) * 100 / progress.submissionCount"
            :color="progress.feedbackFinal === progress.submissionCount ? 'green' : 'blue'"
          />
        </div>
      </div>
    </div>
  </v-card>
</template>

<script>
import { actions } from '@/store/actions'
import { ConfigModule } from '@/store/modules/config'

export default {
  name: 'CorrectionStatistics',
  data () {
    return {
      loaded: false
    }
  },
  computed: {
    statistics () {
      return this.$store.state.statistics
    }
  },
  created () {
    if (ConfigModule.state.config.examId !== '') {
      actions.getStatistics().then(() => { this.loaded = true })
    }
  }
}
</script>

<style scoped>
  .inline-list li {
    display: inline;
    margin: 0px 5px;
  }
  .inline-list span {
    font-weight: bolder;
  }
</style>
